const app = getApp();
const {
    getWxml,
    getStyle,
    getWxml1,
    getStyle1,
} = require("../../pages/activitySharing/poster-data.js");
const {
    isCreateImageSuccess
} = require('../../utils/util.js')
Component({
    options: {

    },
    properties: {
        metaData: {
            type: Object,
            value: {}
        },

    },
    data: {
        isShowQrcode: false,
        poster: null,
        isShowPoster: false
    },
    observers: {

    },
    relations: {

    },
    lifetimes: {

    },
    methods: {
        shareQr() {
            wx.showShareImageMenu({
                path: this.data.qrCode,
            });
        },
        websiteClick() {
            wx.navigateTo({
              url: `/pages/mywebsite/index`,
            })
          },
        showQrcode() {
            this.getImg1();
        },
        shareFriend() {
            wx.showShareImageMenu({
                path: this.data.poster,
            });
        },
        showPoster() {

            this.getImg()
        },
        async getImg1() {
            const obj = {
                img: this.data.metaData.shareQRCode
            }
            console.log(obj);
            const poster = this.selectComponent("#poster");
            wx.showLoading({
                title: '加载中',
            })
            setTimeout(() => {
                const wxml = getWxml1(obj);
                const style = getStyle1();
                const p1 = poster.renderToCanvas({
                    wxml,
                    style
                });
                let container = null;
                p1.then((res) => {
                    container = res;
                    return poster.canvasToTempFilePath();
                }).then((res) => {
                    console.log(res, 'res');
                    this.setData({
                        qrCode: res.tempFilePath,
                        width: container.layoutBox.width,
                        height: container.layoutBox.height,
                        isShowQrcode: true
                    });
                    wx.hideLoading()
                });
            }, 500);
        },
        onVisibleChange2(e) {
            this.setData({
              isShowPoster: e.detail.visible,
            });
          },
          onVisibleChange(e) {

            this.setData({
              isShowQrcode: e.detail.visible,
            });
          },
        async getImg() {
            var isPortraitSuccess = false;
            if (app.globalData.avatarUrl && app.globalData.avatarUrl != '') {
                try {
                    isPortraitSuccess = await isCreateImageSuccess(app.globalData.avatarUrl, "canvas", this);
                } catch (ex) {
                    console.log(ex)
                }
            }
            var obj = {
                title: this.data.metaData.title,
                img: this.data.metaData.imageCoverUrl,
                portrait: isPortraitSuccess ? app.globalData.avatarUrl : "https://pxboss.xiaohebang.cn/system/material/mini/fx/avatar.png",
                name: app.globalData.nickName,
                qrcode: this.data.metaData.shareQRCode,
            };
            const poster = this.selectComponent("#poster");

            wx.showLoading({
                title: '加载中',
            })
            setTimeout(() => {
                const wxml = getWxml(obj);
                const style = getStyle();
                const p1 = poster.renderToCanvas({
                    wxml,
                    style
                });
                console.log(p1);
                let container = null;
                p1.then((res) => {
                    container = res;
                    console.log(container);
                    return poster.canvasToTempFilePath();
                }).then((res) => {
                    this.setData({
                        poster: res.tempFilePath,
                        width: container.layoutBox.width,
                        height: container.layoutBox.height,
                        isShowPoster: true
                    });
                    wx.hideLoading()
                });
            }, 500);
        },
    }
})