const {
    etmsPost,
    etmsPostTemp
} = require("../../com");
const app = getApp();
// pages/accollect/index.js
Page({

    /**
     * 页面的初始数据
     */
    data: {
        tenantId: null,
        collectId: null,
        activityList: null,
        metaData: null,
        isLoadFinish: true,
    },

    /**
     * 生命周期函数--监听页面加载
     */
    async onLoad(query) {
        if (query && query.scene) {
            var parms = query.scene.split("_");
            this.setData({
                tenantId: parms[0],
                collectId: parms[1],
            })
        }
        if (query && query.tenantId) {
            var tenantId = "";
            var collectId = "";
            if (query.tenantId) {
                tenantId = query.tenantId;
            }
            if (query.collectId) {
                collectId = query.collectId
            }
            this.setData({
                tenantId: tenantId,
                collectId: collectId,
            })
        }
        this.goInit(3);
        wx.showShareMenu({
            withShareTicket: true, // 展示默认分享按钮
            menus: ['shareAppMessage', 'shareTimeline'] //分享好友 
        })

    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {
        this.goInit(2);
    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        this.goInit(1);
    },
    async goInit(a) {
        //请求锁
        if (!this.data.isLoadFinish) {
            return
        }
        this.setData({
            isLoadFinish: false
        })
        //未登录走这个
        if (!app.globalData.s) {

            await this.login()

        }
        wx.showToast({
            title: '加载中', //设置标题
            mask: true, //是否打开遮罩,默认不打开
            icon: 'loading' //图标样式，none为无图标
        });
        this.init();
    },
    setLoginInfo(res) {
        app.globalData.s = res.s;
        app.globalData.u = res.u;
        app.globalData.openId = res.openId;
        app.globalData.unionid = res.unionid;
        app.globalData.nickName = res.nickName;
        app.globalData.avatarUrl = res.avatarUrl;
        app.globalData.phone = res.phone;
        if (res.avatarUrl) {
            app.globalData.isGetUser = true;
        }
    },
    async login() {
        var that = this;
        return new Promise((resolve, reject) => {
            wx.login({
                success: (res) => {
                    // 发送 res.code 到后台换取 openId, sessionKey, unionId
                    resolve( etmsPostTemp(
                        "openParent2/WxMiniLogin", {
                            code: res.code,
                        },
                        that.setLoginInfo,
                    )) ;
                 
                },
            });
        })
    },
    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {


    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {
        var bascInfo = this.data.metaData;
        var path = `pages/accollect/index?tenantId=${this.data.tenantId}&collectId=${this.data.collectId}`
        return {
            title: bascInfo.title,
            imageUrl: bascInfo.imageCoverUrl,
            path: path,
        }
    },
    onShareTimeline() {
        var bascInfo = this.data.metaData;
        var path = `pages/accollect/index?tenantId=${this.data.tenantId}&collectId=${this.data.collectId}`
        console.log(2222);
        return {
            title: bascInfo.title,
            imageUrl: bascInfo.imageCoverUrl,
            path: path,
        }
    },
    /**
     * 将阿伯数字转成中文
     */
    addChinese(n) {
        var cnum = ['零', '一', '二', '三', '四', '五', '六', '七', '八', '九', '十'];

        function rp(n) {
            var s = '';
            n = '' + n; // 数字转为字符串
            for (var i = 0; i < n.length; i++) {
                s += cnum[parseInt(n.charAt(i))];
            }
            if (s.length == 2) { // 两位数的时候
                // 如果个位数是0的时候，0改成十
                if (s.charAt(1) == cnum[0]) {
                    s = s.charAt(0) + cnum[10];
                    // 如果是一十改成十
                    if (s == cnum[1] + cnum[10]) {
                        s = cnum[10]
                    }
                } else if (s.charAt(0) == cnum[1]) {
                    // 如果十位数是一的话改成十
                    s = cnum[10] + s.charAt(1);
                } else if (s.charAt(0) == cnum[2]) {
                    // 如果十位数是二的话改成十二
                    s = cnum[2] + cnum[10] + s.charAt(1);
                } else if (s.charAt(0) == cnum[3]) {
                    s = cnum[3] + cnum[10] + s.charAt(1);
                } else if (s.charAt(0) == cnum[4]) {
                    s = cnum[4] + cnum[10] + s.charAt(1);
                } else if (s.charAt(0) == cnum[5]) {
                    s = cnum[5] + cnum[10] + s.charAt(1);
                } else if (s.charAt(0) == cnum[6]) {
                    s = cnum[6] + cnum[10] + s.charAt(1);
                } else if (s.charAt(0) == cnum[7]) {
                    s = cnum[7] + cnum[10] + s.charAt(1);
                } else if (s.charAt(0) == cnum[8]) {
                    s = cnum[8] + cnum[10] + s.charAt(1);
                } else if (s.charAt(0) == cnum[9]) {
                    s = cnum[9] + cnum[10] + s.charAt(1);
                } else if (s.charAt(0) == cnum[10]) {
                    s = cnum[10] + cnum[10] + s.charAt(1);
                }

            }
            return s;
        }
        return rp(n)
    },
    goDetail(e) {
        const item = e.currentTarget.dataset['obj']
        let url = "";
        switch (item.bascInfo.activityType) {

            case 0:

                url = `../acdetail1/index?scene=${item.bascInfo.tenantId}_${item.bascInfo.activityMainId}`;
                wx.navigateTo({
                    url: url
                })
                break;
            case 2:
                url = `../acdetail4/index?scene=${item.bascInfo.tenantId}_${item.bascInfo.activityMainId}`;
                wx.navigateTo({
                    url: url
                })
                break;
            case 1:
                url = `../acdetail2/index?scene=${item.bascInfo.tenantId}_${item.bascInfo.activityMainId}`;
                wx.navigateTo({
                    url: url
                })
                break;
            case 3:
                url = `../acdetail3/index?scene=${item.bascInfo.tenantId}_${item.bascInfo.activityMainId}`;
                wx.navigateTo({
                    url: url
                })
                break;
        }

    },
    isShowCountDownTime(data) {
        let v = 0;
        if (data.teamLeaderRoute && data.teamLeaderRoute.activityRouteId) {
            var tempTeamLeaderRoute = data.teamLeaderRoute;
            var temmpTotalCountDownTime = tempTeamLeaderRoute.exTimeCountDown;
            v = temmpTotalCountDownTime
        }
        return v
    },
    c(data) {
        if (data.teamLeaderRoute && data.teamLeaderRoute.activityRouteId) {
            var tempTeamLeaderRoute = data.teamLeaderRoute;
            var temmpTotalCountDownTime = tempTeamLeaderRoute.exTimeCountDown;
            return temmpTotalCountDownTime
        } else {
            return false
        }
    },
    init() {
        etmsPost(
            app.globalData,
            "openParent2/WxMiniActivityCollectGet", {
                tenantId: this.data.tenantId,
                collectId: this.data.collectId,
            },
            (data) => {

                app.globalData.microWebHomeUrl = data.activityList[0].wxMiniTenantConfig.microWebHomeUrl;
                data.activityList = data.activityList.map((value, index) => {
                    let datac = data;
                    return {
                        ...value,
                        Chinese: this.addChinese(index + 1),
                        isShowCountDownTime: this.c(datac) ? true : false,
                        totalCountDownTime: this.c(datac),
                    }
                })
                wx.setNavigationBarTitle({
                    title: data.title
                })
                wx.hideToast();
                this.setData({
                    activityList: data.activityList,
                    metaData: data,
                    isLoadFinish: true,
                })
            }
        );


    }
})