const {
  etmsPost
} = require("../../com");
const app = getApp();
import Dialog from 'tdesign-miniprogram/dialog/index';
const {
  getWxml,
  getStyle,
  getWxml1,
  getStyle1,
} = require("../activitySharing/poster-data.js");
const {
  isCreateImageSuccess
} = require('../../utils/util.js')
Page({
  data: {
    tenantId: "",
    activityMainId: "",
    activityRouteItemId: "",
    userId: "",
    isLoadFinish: false,
    activityBag: {},
    hagglingType: 0,
    teamLeaderRoute: {},
    haggleLogsView: [],
    styleType: 0,
    isPageLoad: false,
    endTime: "",
    isSubJoinLoading: false,
    isSubOkLoading: false,
    isHagglingAssistLoading: false,
    totalCountDownTime: 0,
    isShowCountDownTime: true,
    // 全部弹幕列表
    allDanmuList: [],
    // 当前弹幕列表
    danmuList: [],
    // 弹幕计时器
    danmuIntervalId: null,
    pageSizeDynamicBullet: 20,
    pageCurrentDynamicBullet: 1,
    isFinishDynamicBullet: false,
    hagglingProgress: 0,
    canIUseGetUserProfile: false,
    isShowQrcode: false,
    poster: null,
    isShowPoster: false,
    distributionInfo: {},
    qrCode: null,
    isShowXiaohebang: false,
    activityExInfo: {}
  },
  async getImg1() {
    const obj = {
      img: this.data.activityBag.bascInfo.shareQRCode
    }
    console.log(obj);
    const poster = this.selectComponent("#poster");
    wx.showLoading({
      title: '加载中',
    })
    setTimeout(() => {
      const wxml = getWxml1(obj);
      const style = getStyle1();
      const p1 = poster.renderToCanvas({
        wxml,
        style
      });
      let container = null;
      p1.then((res) => {
        container = res;
        return poster.canvasToTempFilePath();
      }).then((res) => {
        console.log(res, 'res');
        this.setData({
          qrCode: res.tempFilePath,
          width: container.layoutBox.width,
          height: container.layoutBox.height,
          isShowQrcode: true
        });
        wx.hideLoading()
      });
    }, 500);
  },
  onVisibleChange2(e) {
    this.setData({
      isShowPoster: e.detail.visible,
    });
  },
  onVisibleChange(e) {

    this.setData({
      isShowQrcode: e.detail.visible,
    });
  },
  shareQr() {
    wx.showShareImageMenu({
      path: this.data.qrCode,
    });
  },
  async getImg() {
    var isPortraitSuccess = false;
    if (app.globalData.avatarUrl && app.globalData.avatarUrl != '') {
      try {
        isPortraitSuccess = await isCreateImageSuccess(app.globalData.avatarUrl, "canvas", this);
      } catch (ex) {
        console.log(ex)
      }
    }
    var obj = {
      title: this.data.activityBag.bascInfo.title,
      img: this.data.activityBag.bascInfo.coverImage,
      portrait: isPortraitSuccess ? app.globalData.avatarUrl : "https://pxboss.xiaohebang.cn/system/material/mini/fx/avatar.png",
      name: app.globalData.nickName,
      qrcode: this.data.activityBag.bascInfo.shareQRCode,
    };
    const poster = this.selectComponent("#poster");

    wx.showLoading({
      title: '加载中',
    })
    setTimeout(() => {
      const wxml = getWxml(obj);
      const style = getStyle();
      const p1 = poster.renderToCanvas({
        wxml,
        style
      });
      console.log(p1);
      let container = null;
      p1.then((res) => {
        container = res;
        console.log(container);
        return poster.canvasToTempFilePath();
      }).then((res) => {
        this.setData({
          poster: res.tempFilePath,
          width: container.layoutBox.width,
          height: container.layoutBox.height,
          isShowPoster: true
        });
        wx.hideLoading()
      });
    }, 500);
  },
  showQrcode() {
    // this.setData({
    //   isShowQrcode: true
    // })
    this.getImg1();
  },
  showPoster() {

    this.getImg()
  },
  // 下载图片
  shareFriend() {
    wx.showShareImageMenu({
      path: this.data.poster,
    });
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(query) {
    console.log(query)
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
    if (query && query.scene) {
      var parms = query.scene.split("_");
      var tenantId = parms[0];
      var userId = "";
      if (tenantId.indexOf('.') != -1) {
        var myTenantInfo = tenantId.split(".");
        tenantId = myTenantInfo[0];
        userId = myTenantInfo[1];
      }
      var activityId = parms[1];
      var tempActivityRouteItemId = "";
      if (parms.length >= 3) {
        tempActivityRouteItemId = parms[2];
      }
      this.setData({
        tenantId: tenantId,
        activityMainId: activityId,
        activityRouteItemId: tempActivityRouteItemId,
        userId: userId
      });
    }
    if (query && query.tenantId) {
      var tenantId = "";
      var activityId = "";
      var routeitemId = "";
      var userId = "";
      if (query.tenantId) {
        tenantId = query.tenantId;
      }
      if (query.activityId) {
        activityId = query.activityId
      }
      if (query.routeitemId) {
        routeitemId = query.routeitemId;
      }
      if (query.userId) {
        userId = query.userId
      }
      this.setData({
        tenantId: tenantId,
        activityMainId: activityId,
        activityRouteItemId: routeitemId,
        userId: userId
      });
    }
    this.initActivityData();

    wx.showShareMenu({
      withShareTicket: true,
      menus: ['shareAppMessage', 'shareTimeline']
    })
  },
  initActivityData() {
    if (this.data.isLoadFinish) {
      return;
    }
    this.setData({
      isLoadFinish: true
    })
    if (!app.globalData.s&& !app.globalData.singlePage) {
      setTimeout(() => {
        this.setData({
          isLoadFinish: false
        })
        this.initActivityData();
      }, 10);
      return;
    }
    if (this.data.activityRouteItemId) {
      etmsPost(
        app.globalData,
        "openParent2/WxMiniActivityHomeGet2", {
          tenantId: this.data.tenantId,
          activityRouteItemId: this.data.activityRouteItemId,
        },
        (data) => {
          this.analysisActivityData(data);
        }
      );
    } else {
      etmsPost(
        app.globalData,
        "openParent2/WxMiniActivityHomeGet", {
          tenantId: this.data.tenantId,
          activityMainId: this.data.activityMainId,
        },
        (data) => {
          this.analysisActivityData(data);
        }
      );
    }
  },
  analysisActivityData(data) {
    wx.setNavigationBarTitle({
      title: data.bascInfo.title
    })

    var tempHaggleLogsView = [];
    if (data.teamLeaderRoute && data.teamLeaderRoute.activityRouteId) {
      this.setData({
        hagglingProgress: parseInt(data.teamLeaderRoute.hagglingProgress)
      })
      var tempTeamLeaderRoute = data.teamLeaderRoute;
      var temmpTotalCountDownTime = tempTeamLeaderRoute.exTimeCountDown;
      if (tempTeamLeaderRoute.exTimeCountDown <= 0) {
        this.setData({
          isShowCountDownTime: false
        });
      }
      this.setData({
        totalCountDownTime: temmpTotalCountDownTime
      });
    }
    this.setData({
      activityBag: data,
      teamLeaderRoute: data.teamLeaderRoute,
      haggleLogsView: tempHaggleLogsView,
      styleType: data.bascInfo.styleType,
      endTime: data.bascInfo.endTime,
      hagglingType: data.bascInfo.hagglingType,
      activityExInfo: data.activityExInfo,
      isShowXiaohebang: data.isHideXiaohebang == false
    })

    this.initActivityCall();
    if (data.bascInfo.globalOpenBullet) {
      this.initDynamicBullet();
    }
    app.globalData.microWebHomeUrl = this.data.activityBag.wxMiniTenantConfig.microWebHomeUrl;
    app.globalData.currentActivityBag2 = data;
    var status = data.bascInfo.activityStatus;
    if (status != 1) {
      Dialog.alert({
        title: `活动${data.bascInfo.activityStatusDesc}`,
        confirmBtn: '我知道了',
      }).then(() => {
        console.log('success')
      });
    }
  },

  initActivityCall() {
    if (this.data.isPageLoad) {
      return;
    }
    this.setData({
      isPageLoad: true
    });
    var mydata = this.data.activityBag;
    etmsPost(
      app.globalData,
      "openParent2/WxMiniActivityCall", {
        tenantId: mydata.bascInfo.tenantId,
        activityMainId: mydata.bascInfo.activityMainId,
      },
      (data) => {}
    );
    var openParms = wx.getLaunchOptionsSync();
    if (openParms.shareTicket) {
      etmsPost(
        app.globalData,
        "openParent2/WxMiniActivityShare", {
          tenantId: mydata.bascInfo.tenantId,
          activityMainId: mydata.bascInfo.activityMainId,
        },
        (data) => {}
      );
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {
    this.initActivityData();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    this.initActivityData();
  },
  initDynamicBullet() {
    this.DynamicBulletGetPaging();
  },
  /** 从后端获取弹幕 */
  DynamicBulletGetPaging() {
    console.log("加载弹幕")
    if (this.data.isFinishDynamicBullet) {
      return;
    }
    etmsPost(
      app.globalData,
      "openParent2/WxMiniActivityDynamicBulletGetPaging", {
        pageSize: this.data.pageSizeDynamicBullet,
        pageCurrent: this.data.pageCurrentDynamicBullet,
        tenantId: this.data.activityBag.bascInfo.tenantId,
        activityMainId: this.data.activityBag.bascInfo.activityMainId,
      },
      (resData) => {
        var tempItem = resData.dataItems;
        if (tempItem.length === 0) {
          this.setData({
            isFinishDynamicBullet: true
          });
        } else {
          this.asayDynamicBullet(tempItem);
          this.setData({
            pageCurrentDynamicBullet: this.data.pageCurrentDynamicBullet + 1
          });
          setTimeout(() => {
            this.DynamicBulletGetPaging();
          }, 5000);
        }
      }
    );
  },
  asayDynamicBullet(items) {
    const allDanmuList = []
    var index = 1;
    items.forEach(myitem => {
      allDanmuList.push({
        id: index,
        text: `${myitem.studentNameDesc}:${myitem.tagDesc}`,
        img: myitem.avatarUrl,
        // 出现时间 间隔： 1000ms - 5000ms
        time: parseInt(Math.random() * 50 + 10 * index) * 100,
        // 出现高度 50px - 150px
        top: Math.random() * 50 + 100 + "px",
      })
      index++;
    });
    this.setData({
      allDanmuList: allDanmuList
    })

    this.runDanmu();
  },
  /** 开始滚动弹幕 */
  runDanmu() {
    const danmuList = []
    let time = 0
    const danmuIntervalId = setInterval(() => {
      // 当前时间显示的弹幕
      const danmu = this.data.allDanmuList.find(dm => dm.time == time * 100)
      // 5秒钟后移除
      const danmuRemove = danmuList.find(dm => dm.time + 5000 < time * 100)

      // 添加弹幕
      if (danmu) {
        danmuList.push(danmu)
        this.setData({
          danmuList: danmuList
        })
      }

      // 移除滚动完的弹幕
      if (danmuRemove) {
        const danmuRemoveIndex = danmuList.findIndex(dm => dm.id == danmuRemove.id)
        console.log(danmuRemoveIndex);
        if (danmuRemoveIndex != -1) {
          danmuList.splice(danmuRemoveIndex, 1)
        }
        this.setData({
          danmuList: danmuList
        })
      }

      time++
    }, 100)

    this.setData({
      danmuIntervalId: danmuIntervalId
    })

  },
  /** 停止滚动弹幕 */
  stopDanmu() {
    clearInterval(this.data.danmuIntervalId)
  },
  phoneClick(event) {
    wx.makePhoneCall({
      phoneNumber: this.data.activityBag.bascInfo.globalPhone,
      success() {},
      fail() {}
    })
  },
  websiteClick() {
    wx.navigateTo({
      url: `../mywebsite/index`,
    })
  },
  goRouteMore() {
    wx.navigateTo({
      url: `../routeItems2/index`,
    })
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {
    this.setData({
      isLoadFinish: false,
      isSubJoinLoading: false,
      isSubOkLoading: false
    })

    this.stopDanmu()
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },


  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {
    var bascInfo = this.data.activityBag.bascInfo;
    var teamLeaderRoute = this.data.activityBag.teamLeaderRoute;
    var path = `pages/acdetail4/index?tenantId=${bascInfo.tenantId}&activityId=${bascInfo.activityMainId}&s=1`
    if (bascInfo.activityRouteItemId) {
      path += `&routeitemId=${bascInfo.activityRouteItemId}`
    }
    if (this.data.userId) {
      path += `&userId=${this.data.userId}`
    }
    console.log(path);
    return {
      title: bascInfo.title,
      imageUrl: bascInfo.coverImage,
      path: path,
    }
  },
  onShareTimeline() {
    var bascInfo = this.data.activityBag.bascInfo;
    var teamLeaderRoute = this.data.activityBag.teamLeaderRoute;
    var path = `tenantId=${bascInfo.tenantId}&activityId=${bascInfo.activityMainId}&s=1`
    if (bascInfo.activityRouteItemId) {
      path += `&routeitemId=${bascInfo.activityRouteItemId}`
    }
    return {
      title: bascInfo.title,
      imageUrl: bascInfo.coverImage,
      query: path,
    }
  },
  handleGetUserProfile() {
    wx.getUserProfile({
      desc: '用于获取参与活动的学员的头像',
      success: (res) => {
        console.log(res.userInfo);
        this.processGetUserInfo(res.userInfo);
      }
    })
  },
  processGetUserInfo(myuser) {},
  //去成团
  goJoin(event) {

  },
  //去开团
  goGroupPurchaseStart() {
    this.goGroupPurchaseStartProcess();
  },
  goGroupPurchaseStartProcess() {
    this.setData({
      isSubOkLoading: true
    });
    var mydata = this.data.activityBag;
    var tenantId = mydata.bascInfo.tenantId;
    var activityMainId = mydata.bascInfo.activityMainId;
    etmsPost(
      app.globalData,
      "openParent2/WxMiniSeckillStartCheck", {
        tenantId: tenantId,
        activityMainId: activityMainId,
      },
      (data) => {
        this.setData({
          isSubOkLoading: false
        });
        wx.navigateTo({
          url: `../goSeckill/index?type=0&tenantId=${tenantId}&&activityMainId=${activityMainId}&userId=${this.data.userId}`,
        })
      }, () => {
        this.setData({
          isSubOkLoading: false
        });
      }
    );
  },
})