// pages/activitySharing.js
const {
  getWxml,
  getStyle
} = require("./poster-data.js");

Page({
  /**
   * 页面的初始数据
   */
  data: {
    poster: "",
    path: "",
    showObj: {}
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    var obj = JSON.parse(options.obj);
    console.log(obj)
    this.setData({
      showObj: obj,
      path: decodeURIComponent(options.path)
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {
    this.genImg();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {},

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {},

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {},

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {},

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {},

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {
    return {
      path: this.data.path
    }
  },

  genImg() {
    const poster = this.selectComponent("#poster");

    wx.showLoading({
      title: '加载中',
    })
    setTimeout(() => {
      const wxml = getWxml(this.data.showObj);
      const style = getStyle();
      const p1 = poster.renderToCanvas({
        wxml,
        style
      });
      let container = null;
      p1.then((res) => {
        container = res;
        console.log(container);
        return poster.canvasToTempFilePath();
      }).then((res) => {
        this.setData({
          poster: res.tempFilePath,
          width: container.layoutBox.width,
          height: container.layoutBox.height,
        });
        wx.hideLoading()
      });
    }, 500);
  },
  shareFriend() {
    wx.showShareImageMenu({
      path: this.data.poster,
    });
  },
});