/**
 * 
 * @param {Object} options 
 * @param {string} options.title 标题
 * @param {string} options.img 大图
 * @param {string} options.portrait 头像
 * @param {string} options.name 姓名
 * @param {string} options.qrcode 二维码
 * @returns 
 */
export const getWxml = ({
    title,
    img,
    portrait,
    name,
    qrcode
}) => {
    return `
  <view class="poster">
    <image class="img" src="${img}" />
    <view class="title-box">
        <text class="title">${title}</text>
    </view>
    <view class="info-box">
      <image class="portrait" src="${portrait}" />
      <view class="info-main">
        <text class="name">${name}</text>
        <text class="desc">分享好课给你</text>
      </view>
      <image class="qrcode" src="${qrcode}" />
    </view>
    <view class="extract-box">
      <text class="extract-text">长按识别小程序</text>
      <image class="extract-icon" src="https://xiaohebang.oss-cn-beijing.aliyuncs.com/system/material/mini/fx/zw.png" />
    </view>
  </view>
  `;
};

export const getStyle = () => {
    return {
        poster: {
            width: 300,
            height: 368,
            padding: 20,
            flexDirection: "column",
            backgroundColor: "#fff",
            borderRadius: 16,
        },
        img: {
            width: 260,
            height: 156,
            borderRadius: 8,
        },
        titleBox: {
            width: 260,
            height: 60,
        },
        title: {
            top: 8,
            width: 260,
            height: 60,
            fontSize: 16,
            lineHeight: "1.5em",
        },
        name: {
            width: 124,
            height: 28,
            fontSize: 16,
            lineHeight: "1.5em",
        },
        desc: {
            width: 124,
            height: 28,
            fontSize: 14,
            lineHeight: "1.5em",
            color: "#666"
        },
        infoBox: {
            top: 8,
            width: 260,
            height: 64,
            flexDirection: "row",
        },
        infoMain: {
            left: 8,
            width: 132,
            height: 60,
        },
        portrait: {
            width: 56,
            height: 56,
            borderRadius: 28,
        },
        qrcode: {
            right: 10,
            width: 84,
            height: 84,
        },
        extractBox: {
            top: 16,
            width: 158,
            height: 30,
            backgroundColor: "#f6f6f8",
            flexDirection: "row",
            borderRadius: 15,
        },
        extractText: {
            left: 16,
            width: 120,
            height: 30,
            verticalAlign: "middle",
        },
        extractIcon: {
            top: 4,
            width: 22,
            height: 22,
            borderRadius: 11,
        },

    };
};

// 单图像导出
/**
 * @param {Object} options 
 * @param {string} options.img 大图
 * @returns 
 */
export const getWxml1 = ({
    img
}) => {
    return `
  <view class="imgBox">
    <image class="img" src="${img}" />
   
  </view>
  `;
};
export const getStyle1 = () => {
    return {
        imgBox:{
            width: 300,
            height: 300,
            padding: 20,
            flexDirection: "column",
            backgroundColor: "#fff",
            borderRadius: 16,
        },
        img :{
            width: 260,
            height: 260,
        }
    }
}