const {
  etmsPost
} = require("../../com");
const config = require("../../config");
const app = getApp();
import Dialog from 'tdesign-miniprogram/dialog/index';

Page({
  data: {
    activityMainId: null,
    tenantId: null,
    userId: "",
    type: 0,
    activityRouteId: null,
    activityBascInfo: {},
    groupPurchaseRule: {},
    teamLeaderRoute: {},
    activityConfig: {},
    studentFieldName1: "",
    studentFieldName2: "",
    isLoadFinish: false,
    studentName: "",
    studentPhone: "",
    studentFieldValue1: "",
    studentFieldValue2: "",
    isSubOkLoading: false,
    canIUseGetUserProfile: false,
    avatarUrl: "",
    isGetPhone: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    console.log(options)
    wx.hideShareMenu({
      menus: ['shareAppMessage', 'shareTimeline']
    });
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
    var activityRouteId = 0;
    if (parseInt(options.type) === 1) {
      activityRouteId = options.activityRouteId
    }
    this.setData({
      type: options.type,
      tenantId: options.tenantId,
      activityMainId: options.activityMainId,
      userId: options.userId,
      activityRouteId: activityRouteId,
      studentPhone: app.globalData.phone,
      studentName: app.globalData.name
    })
    this.initActivityGetSimple();
    console.log(this.data.activityMainId)
    this.setData({
      avatarUrl: app.globalData.avatarUrl
    })
  },
  initActivityGetSimple() {
    etmsPost(
      app.globalData,
      "openParent2/WxMiniActivityGetSimple", {
        tenantId: this.data.tenantId,
        activityMainId: this.data.activityMainId,
        activityRouteId: this.data.activityRouteId
      },
      (data) => {
        this.analysisActivityData(data);
      }
    );
  },
  analysisActivityData(data) {
    var groupPurchaseRule = data.groupPurchaseRule.items.reverse();
    this.setData({
      activityBascInfo: data,
      studentFieldName1: data.studentFieldName1,
      studentFieldName2: data.studentFieldName2,
      groupPurchaseRule: groupPurchaseRule,
      teamLeaderRoute: data.teamLeaderRoute,
      activityConfig: data.activityConfig,
      isLoadFinish: true
    });
  },
  onChooseAvatar(e) {
    const {
      avatarUrl
    } = e.detail;
    var etmsData = {
      openId: app.globalData.openId,
      unionid: app.globalData.unionid,
      miniPgmUserId: app.globalData.u
    };
    let that = this;
    wx.uploadFile({
      url: config.upLoadMiniProgramAvatar,
      filePath: avatarUrl,
      name: 'file',
      formData: {
        "etmsData": JSON.stringify(etmsData)
      },
      success(res) {
        var obj = JSON.parse(res.data)
        that.setData({
          avatarUrl: obj.resultData
        })
      }
    })
  },
  getPhoneNumber(e) {
    let errMsg = e.detail.errMsg;
    if (errMsg == 'getPhoneNumber:ok') {
      etmsPost(
        app.globalData,
        "openParent2/DecodedPhoneNumber", {
          EncryptedData: e.detail.encryptedData,
          Iv: e.detail.iv,
        },
        (data) => {
          this.setData({
            studentPhone: data.phone,
            isGetPhone: true
          });
        }
      );
    }
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },
  handleGetUserProfile(e) {
    if (!this.data.studentName || this.data.studentName === '') {
      wx.showToast({
        title: "请输入学员姓名",
        icon: "none",
        duration: 2000,
      });
      return;
    }
    if (!this.data.studentPhone || this.data.studentPhone === '') {
      wx.showToast({
        title: "请获取手机号码",
        icon: "none",
        duration: 2000,
      });
      return;
    }
    wx.getUserProfile({
      desc: '用于获取参与活动的学员的头像',
      success: (res) => {
        console.log(res.userInfo);
        this.processGetUserInfo(res.userInfo);
      }
    })
  },
  processGetUserInfo(myuser) {
    // etmsPost(
    //   app.globalData,
    //   "openParent2/WxMiniEditUserInfo", {
    //     nickName: myuser.nickName,
    //     avatarUrl: myuser.avatarUrl,
    //   },
    //   () => {}
    // );
    this.goGroupPurchaseGoProcess();
  },
  goGroupPurchaseGo(info) {
    if (info && info.nickName) {
      this.processGetUserInfo(info);
      return;
    }
    this.goGroupPurchaseGoProcess();
  },
  goGroupPurchaseGoProcess() {
    if (!this.data.studentName || this.data.studentName === '') {
      wx.showToast({
        title: "请输入学员姓名",
        icon: "none",
        duration: 2000,
      });
      return;
    }
    if (!this.data.studentPhone || this.data.studentPhone === '') {
      wx.showToast({
        title: "请获取手机号码",
        icon: "none",
        duration: 2000,
      });
      return;
    }
    this.setData({
      isSubOkLoading: true
    });
    if (parseInt(this.data.type) === 1) { //去成团
      etmsPost(
        app.globalData,
        "openParent2/WxMiniGroupPurchaseJoin", {
          tenantId: this.data.activityBascInfo.tenantId,
          activityMainId: this.data.activityBascInfo.activityMainId,
          ActivityRouteId: this.data.activityRouteId,
          studentName: this.data.studentName,
          studentPhone: this.data.studentPhone,
          studentFieldValue1: this.data.studentFieldValue1,
          studentFieldValue2: this.data.studentFieldValue2,
          userId:this.data.userId
        },
        (data) => {
          this.analysisResult(data);
        }, () => {
          this.setData({
            isSubOkLoading: false
          });
        }
      );
    } else { //开团
      etmsPost(
        app.globalData,
        "openParent2/WxMiniGroupPurchaseStartGo ", {
          tenantId: this.data.activityBascInfo.tenantId,
          activityMainId: this.data.activityBascInfo.activityMainId,
          studentName: this.data.studentName,
          studentPhone: this.data.studentPhone,
          studentFieldValue1: this.data.studentFieldValue1,
          studentFieldValue2: this.data.studentFieldValue2,
          userId:this.data.userId
        },
        (data) => {
          this.analysisResult(data);
        }, () => {
          this.setData({
            isSubOkLoading: false
          });
        }
      );
    }
  },
  analysisResult(data) {
    console.log(data);
    var payInfo = data.payInfo;
    if (data.isMustPay) {
      wx.requestPayment({
        timeStamp: payInfo.timeStamp,
        nonceStr: payInfo.nonceStr,
        package: payInfo.package_str,
        signType: payInfo.signType,
        paySign: payInfo.paySign,
        success: () => {
          this.paySuccess(data);
        },
        fail: () => {
          this.setData({
            isSubOkLoading: false
          });
        }
      });
      return;
    } else {
      wx.showToast({
        title: "报名成功",
        icon: "success",
        duration: 2000,
        complete: () => {
          wx.switchTab({
            url: `../index/index`,
          })
        }
      });
      this.setData({
        isSubOkLoading: false
      });
    }
  },
  paySuccess(data) {
    etmsPost(
      app.globalData,
      "openParent2/WxMiniPaySuccess", {
        tenantId: this.data.activityBascInfo.tenantId,
        activityRouteItemId: data.activityRouteItemId
      },
      (data) => {
        wx.showToast({
          title: "报名成功",
          icon: "success",
          duration: 2000,
          complete: () => {
            wx.switchTab({
              url: `../index/index`,
            })
          }
        });
        this.setData({
          isSubOkLoading: false
        });
      });
  }
})