const {
  etmsPost
} = require("../../com");
const config = require("../../config");
const app = getApp();

Page({
  /**
   * 页面的初始数据
   */
  data: {
    isGetUser: false,
    nickName: "",
    avatarUrl: "",
    canIUseGetUserProfile: false
  },
  handleGetUserProfile(e) {
    wx.getUserProfile({
      desc: '用于获取参与活动的学员的头像',
      success: (res) => {
        console.log(res.userInfo);
        this.processGetUserInfo(res.userInfo);
      }
    })
  },
  onChooseAvatar(e) {
    const {
      avatarUrl
    } = e.detail;
    var etmsData = {
      openId: app.globalData.openId,
      unionid: app.globalData.unionid,
      miniPgmUserId: app.globalData.u
    };
    let that = this;
    wx.uploadFile({
      url: config.upLoadMiniProgramAvatar,
      filePath: avatarUrl,
      name: 'file',
      formData: {
        "etmsData": JSON.stringify(etmsData)
      },
      success(res) {
        var obj = JSON.parse(res.data)
        that.setData({
          avatarUrl: obj.resultData
        })
      }
    })
  },
  getUserInfo(info) {
    if (info.detail.userInfo) {
      console.log(info.detail.userInfo)
      var myuser = info.detail.userInfo;
      this.processGetUserInfo(myuser);
    }
  },
  processGetUserInfo(myuser) {
    this.setNewData(myuser);
    // etmsPost(
    //   app.globalData,
    //   "openParent2/WxMiniEditUserInfo", {
    //     nickName: myuser.nickName,
    //     avatarUrl: myuser.avatarUrl,
    //   },
    //   () => {
    //     this.setNewData(myuser);
    //   }
    // );
  },
  setNewData(info) {
    this.setData({
      nickName: info.nickName
    })
    this.setData({
      avatarUrl: info.avatarUrl
    })
    this.setData({
      isGetUser: true
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    // if (wx.getUserProfile) {
    //   this.setData({
    //     canIUseGetUserProfile: true
    //   })
    // }
    this.setData({
      nickName: app.globalData.nickName
    })
    this.setData({
      avatarUrl: app.globalData.avatarUrl
    })
    this.setData({
      isGetUser: app.globalData.isGetUser
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {},

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {},

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {},

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {},

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {},

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {},
});