const {
  etmsPost
} = require("../../com");
const app = getApp();

Page({

  data: {
    activityBag: {},
    myActivityRoutes: [],
    pageSize: 20,
    pageCurrent: 1,
    tenantId: null,
    activityMainId: null,
    isFinish: false,
    recordCount: 0,
    isSubJoinLoading: false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    var currentActivityBag = app.globalData.currentActivityBag;
    var myActivityBascInfo = currentActivityBag.bascInfo;
    wx.setNavigationBarTitle({
      title: currentActivityBag.bascInfo.title
    })
    this.setData({
      activityBag: currentActivityBag,
      tenantId: myActivityBascInfo.tenantId,
      activityMainId: myActivityBascInfo.activityMainId
    });
    this.getActivityRouteItem();
  },

  getActivityRouteItem() {
    etmsPost(
      app.globalData,
      "openParent2/WxMiniActivityRouteItemMoreGetPaging", {
        pageSize: this.data.pageSize,
        pageCurrent: this.data.pageCurrent,
        tenantId: this.data.tenantId,
        activityMainId: this.data.activityMainId,
      },
      (data) => {
        this.analysisActivityRouteItem(data);
      }
    );
  },
  analysisActivityRouteItem(resData) {
    var tempList = this.data.myActivityRoutes.concat(resData.dataItems);
    this.setData({
      recordCount: resData.recordCount,
      myActivityRoutes: tempList
    })
    if (tempList.length >= resData.recordCount) {
      this.setData({
        isFinish: true
      })
    }
  },

  changeRouteItem(event) {
    var mydata = event.currentTarget.dataset;
    var index = mydata.index;
    var currentindex = mydata.currentindex;
    var items = this.data.myActivityRoutes[index].joinRouteItems;
    if (currentindex >= items.length - 1) {
      currentindex = 0;
    } else {
      currentindex++;
    }
    var tempjoinRouteItems = this.data.myActivityRoutes;
    tempjoinRouteItems[index].currentAvatarUrl = items[currentindex].avatarUrl;
    tempjoinRouteItems[index].currentStudentNameDesc = items[currentindex].studentNameDesc;
    tempjoinRouteItems[index].currentIndex = currentindex;
    this.setData({
      myActivityRoutes: tempjoinRouteItems
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {
    console.log("111")
    console.log(this.data.isFinish)
    if (!this.data.isFinish) {
      this.setData({
        pageCurrent: this.data.pageCurrent + 1
      });
      this.getActivityRouteItem();
    }
  },
  goJoin(event) {
    this.setData({
      isSubJoinLoading: true
    });
    var mydata = event.currentTarget.dataset;
    var activityRouteId = mydata.rid;
    console.log(activityRouteId)
    var mydata = this.data.activityBag;
    var tenantId = mydata.bascInfo.tenantId;
    var activityMainId = mydata.bascInfo.activityMainId;
    etmsPost(
      app.globalData,
      "openParent2/WxMiniGroupPurchaseJoinCheck", {
        tenantId: tenantId,
        activityMainId: activityMainId,
        ActivityRouteId: activityRouteId
      },
      (data) => {
        this.setData({
          isSubJoinLoading: false
        });
        wx.navigateTo({
          url: `../gosubmitGroupPurchase/index?type=1&activityRouteId=${activityRouteId}&tenantId=${tenantId}&&activityMainId=${activityMainId}`,
        })
      }, () => {
        this.setData({
          isSubJoinLoading: false
        });
      }
    );
  },
})